<?php

/**
 * avoca_conocimiento_det actions.
 *
 * @package    cobro_coactivo
 * @subpackage avoca_conocimiento_det
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class avoca_conocimiento_detActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_AVOCA_CONOC_DET_V',
        'CBR_AVOCA_CONOC',
        'CBR_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_AVOCA_CONOC' =>
        array(
            'id_avoca_conoc' => 'CBR_AVOCA_CONOC_DET_V'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_AVOCA_CONOC'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_AVOCA_CONOC_DET_V' =>
        array(
            'id_avoca_conoc' => 'id_avoca_conoc',
            'id_remision_titulo' => 'id_remision_titulo',
            'observaciones' => 'observaciones',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'id_par' => 'id_par',
            'estado_remi' => 'completo_remision'
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => 'no_auto',
            'fecha' => 'fecha',
            'adjunto' => 'adjunto',
            'id_plantilla' => 'id_plantilla',
            'id_tipo_documento' => 'id_tipo_documento'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'anho_remision', 'numero_remision', 'no_auto', 'fecha'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     * IN - where de in de oracle, para numero
     * INTEXT - where de in de oracle, para texto
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_AVOCA_CONOC_DET_V' =>
        array(
            'id_avoca_conoc,a' => array(' != ' => array(-1)),
            'id_avoca_conoc,b' => array(' = ' => array('id_avoca_conoc')),
            'id_remision_titulo' => array(' = ' => array('id_remision_titulo')),
            'numero_remision' => array(' = ' => array('numero_remision')),
            'anho_remision' => array(' = ' => array('anho_remision')),
            'numero_correpondencia' => array(' = ' => array('numero_correpondencia')),
            'id_par' => array(' = ' => array('id_par')),
            'estado_remi' => array(' = ' => array('estado_remi')),
            'rownum, start' => array('>' => array('_startRow')),
            'rownum, end' => array(' <= ' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = null; //identificador de la tabla
    protected $id_names = array('id_avoca_conoc', 'id_remision_titulo'); //llave primaria
    protected $field_names = array('observaciones', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_AVOCA_CONOC_DET'; //tabla en la cual se aplican los cambios 
    protected $has_secuencia = false; //si posee secuencia la tabla
    
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_avoca_conoc'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {

        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log'] = $request['id_username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_avoca_conoc = $request['id_avoca_conoc'];
        $id_remision_titulo = $request['id_remision_titulo'];

        $sql = <<<EOD
SELECT
    *
FROM cbr_avoca_conoc_det
where
id_avoca_conoc = $id_avoca_conoc
and id_remision_titulo = $id_remision_titulo  
EOD;
        $record = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($record) > 0) {
            $errors['mensaje'] = "NO puede registrarse la misma recepción.";
            $errors['servicio'] = "remision_titulo_det";
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
